
;**************************************************************************
;*   Program SIRPVM17.ASM                                                  *
;*Program nam riadi otky jednosssmernho motora na princpe              *
;*rkovej modulcie ( PWM ). Pre riadenie bo vyuit mikrokontroler      *
;*AT90S2313 fi ATMEL. Riadenie je realizovan pomocou dvoch tlaitiek      *
;*pripojench na 0,b portu D pre zvyovanie otok a 1,b pre ziovanie     *
;*otok. Stlaanm tlaitiek sa men skokom kontanta t.j.hodnota sla   *
;* v acc a tm aj rka generovanch impuzov. Hodnota kroku v uvedenom     *
;*programe bola zvolen 4, V programe je mono tto hodnotu poda potreby  *
;*zmeni,                                                                  *
;***************************************************************************
                                                                        
        .NOLIST	
	.INCLUDE "2313def.inc"	
	.LIST	
	.CSEG	;kdov segment
	.DEF REG=r20	;pracovn register        
        .DEF ACC=R19 ;akultor = register r19       
	
	ldi reg,$00  ; PORT D = vstupn port
       out ddrd,reg 
       LDI REG,RAMEND	
	OUT SPL,REG	;nastav SP na koniec RAM
	LDI REG,$08	
	OUT DDRB,REG	;aktivuj portB na vystup
	LDI REG,0b10000001	;8bitov PWM
	OUT TCCR1A,REG	
	LDI REG,0b00000100	;preddelika 8
	OUT TCCR1B,REG	
	CLR REG	
	OUT OCR1AH,REG	;OCR1AH=$00
	
       
        ldi acc,$a0 ;poiaton stav pre ACC ( sirku impulzov )
zac:    sbis pind,0 ;tlaitko pripojen na 0.b
        rjmp roz    ;portu D - zvovanie rky 
        rjmp nac1   ;impulzov, ana 1,b - zmenovanie 
roz:    sbis pind,1 ;rky impulzov 
        rjmp op1    
        rjmp nac2


op1:    clr reg        ;vynulovanie reg. R31, vyssi byt porovnavacieho     
        adc r31,reg    ;registra citaca/casovaca    
        out ocr1ah,reg ;      "               
        out ocr1al,acc ;zapisanie obsahu acc do nizsieho bytu porovn.reg.
        rcall caka
        rjmp zac  
    
nac1:   sbic pind,0   
        rjmp nac1
        ldi reg,4   ;hodnota kroku ( 4 ) do acc  
        add acc,reg ;naitanie novej hodnoty do acc, pripotanim kroku 
        cpi acc,$fe ; ak je via hodnota ako 0EaH zapi do acc slo
        brsh rovn0  ; 0FAH - v skoku na nvestie rovno0
        rjmp op1

nac2:   sbic pind,1
        rjmp nac2
        ldi reg,4    ;hodnota kroku ( 4 ) do acc 
        sub acc,reg  ;naitanie novej hodnoty do acc, odtanim kroku 
        cpi acc,$08  ;ak je menia hodnota ako 05H zapi do acc slo
        brlo rovn1   ;05H - v skoku na nvestie rovno1
        rjmp op1

rovn0:  ldi acc,$fa  
        rjmp op1
 
rovn1:  ldi acc,$05
        rjmp op1
      
         
caka:    ldi r17,$13  ; oneskorenie 
nav1:    dec r17
         brne nav1
         ret  	

